/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
 ڴӡ̣
 USART1_Tx(PA9)
 ʾʹ USART1(PA9) ӡԿ

*/
#include "debug.h"
#include "stdio.h"

#define rt_uint8_t unsigned char
#define rt_uint16_t unsigned short int
#define rt_uint32_t unsigned int


/* Global typedef */

/* Global define */

/* Global Variable */
static const uint32_t s_keys[16] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
 uint8_t  resq[16] = {0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF};
 uint32_t f_keys[16] = {0};


 struct cpp_packet {
     rt_uint8_t  head[2];
     rt_uint8_t  dev_code[4];
     rt_uint8_t  dev_order[4];
     rt_uint8_t  func_code;
     rt_uint8_t  check_sum;
     rt_uint8_t  len;
     rt_uint8_t  msg_array[240];
 }__attribute__((packed));


 int cpp_exec(struct cpp_packet *cmd_packet) {
     printf("size: %d\n", sizeof( struct cpp_packet));
     printf("device code: %x", *(rt_uint32_t *)cmd_packet->dev_code);
     printf("device code: %x", *(rt_uint32_t *)cmd_packet->dev_order);

     return 0;
 }

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
uint32_t temp=0;
int main(void)
{

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	Delay_Init();
	USART_Printf_Init(115200);
//	printf("SystemClk:%d\r\n",SystemCoreClock);
//	printf("This is printf example\r\n");
//
//    f_keys[4]=s_keys[2]^(*(uint32_t*)&resq[2]);


	temp=(*(uint32_t*)&resq[2]);

	printf("resq:%8x\r\n",temp);

    rt_uint32_t code = 0x11012102;
    rt_uint32_t order = 0x12013402;
    rt_uint32_t new_code = 0x99012102;

    struct cpp_packet cmd;
    *(rt_uint16_t *)cmd.head = 0xBBCC;
    *(rt_uint32_t *)cmd.dev_code = code;
    *(rt_uint32_t *)cmd.dev_order = order;
    cmd.func_code = 0xF1;
    *(rt_uint32_t *)cmd.msg_array = new_code;
    cpp_exec(&cmd);
//    printf("resq:%d\r\n",(*(uint32_t*)&resq[2]));
//    printf("resq:%8x\r\n",(*(uint32_t*)&resq[2]));
//    printf("f_keys:%8x\r\n",f_keys[4]);
//    printf("f_keys:%d\r\n",f_keys[4]);

	while(1)
    {

	}
}

